
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Analyze Salem Temperature data
 *
 * @author gorr
 */
public class Temperatures {

    // Columns are:
    //  0     1     2        3         4         5         6      7       8    9       10         11
    // year, LowT, HighT, WarmestT, coldestT, AveMinT, AveMaxT, MeanT, Precip Snow Max24hrPrec Max24hrSnow
    int dataColumn = 7;  // choose which one you want (1 through 11)
    String[] header = new String[2];
    double temperatures[];
    int years[];

    public void analyze() {
        
        
        
        
    }

    /**
     * Read in Salem Temperature data from file. Store the year and
     * corresponding mean temperature. The data was obtained from
     * http://weather-warehouse.com/WeatherHistory/PastWeatherData_SalemMcnaryField_Salem_OR_January.html
     */
    public Temperatures() {
        ArrayList<String> tempList = new ArrayList<>();
        ArrayList<String> yearList = new ArrayList<>();
        boolean verbose = false;
        MyReader reader = new MyReader("src\\salemTemps.txt");
        int cnt = 0;
        String tokens[] = reader.giveMeTheNextLine().split("[\t ]+"); // header
        header[0] = tokens[0];
        header[1] = tokens[dataColumn];
        if (verbose) System.out.println("Header: " + Arrays.toString(tokens));
        while (reader.hasMoreData()) {
            tokens = reader.giveMeTheNextLine().split("[\t ]+");
            if (verbose) 
                for (int i = 0; i < tokens.length; i++) System.out.print(tokens[i] + " :: "); 
            if (verbose) {System.out.println(""); }
            if (tokens[dataColumn].startsWith("NR"))  tempList.add("-1.0");
            else tempList.add(tokens[dataColumn]);
            yearList.add(tokens[0]);
            cnt++;
        }
        if (verbose) System.out.println("total number of lines of data = " + (cnt - 1));
        reader.close();
        temperatures = new double[tempList.size()];
        years = new int[tempList.size()];
        for (int i = 0; i < tempList.size(); i++) {
            temperatures[i] = Double.parseDouble(tempList.get(i));
            years[i] = Integer.parseInt(yearList.get(i));
        }
        System.out.println(this);
    }

    public String toString() {
        StringBuffer sb = new StringBuffer(header[0] + "\t" + header[1] + "\n");
        for (int i = 0; i < years.length; i++) {
            sb.append(years[i] + "\t" + temperatures[i] + "\n");
        }
        return sb.toString();
    }
}
